;=============================================================================
;   - Nokia 1110i,1202,6085
;	 -	  
;=============================================================================
;  LCD      PCF8814
; 			     ( )
; -    ()  96 ,    0 - 95
; 	3        
; 	4        
; :     39 (39 -> HEX = 0x27)  : 0x12,0x07
;          : 0x10,0x00
; 			   ( Y)
;     1...9   0xB0... 0xB8
;   8    9-  
; 
;        
; 	       1   0x41
; 	       2   0x42
; 	       4   0x43
; 	       8   0x44
; 	      10   0x45
; 	      16   0x48
; 	       21   0x65
; 	                 0x90 ... 0x9F
; 	  ( ) 0xA2 
; 	      0xC8
; 	             0xA6
; 	             0xA7
; 	         0xA1
; 	|||||||||||||||||||||||||||||||||
; 	lsb adress -> 
; 	         0xA0
; 	|||||||||||||||||||||||||||||||||
;                     <- lsb adress  
; 	    0  0xAC
; 	                          0xAE
; 	                           0xAF 
; 	RESET lcd                            0xE2
; 	     0xEB
;================================================================================
;	.cseg                  ; FLASH 
	;;  LCD  ATmega8
	.equ  LCD_PORT = PORTB  	;  
	.equ  LCD_SCLK = PB1    	;   
	.equ  LCD_SDA  = PB2    	;    
	.equ  LCD_CS   = PB3    	;  LCD
	.equ  LCD_RES  = PB4    	;  LCD

;=================================================================================
init_lcd:              ;   
		ldi     temp,0xE2      ;    LCD
		rcall   lcd_cmd        ;     
		ldi     temp,0xEB      ;   
		rcall   lcd_cmd        ;     
		ldi     temp,0x2F      ;  
		rcall   lcd_cmd        ;     
		ldi     temp,0xA1      ;  LSB -> MSB  Nokia 1110i lcd
	;	ldi     temp,0xA0      ;  MSB -> LSB Nokia 1202 lcd
		rcall   lcd_cmd        ;     
		ldi     temp,0x95      ;   090 ... 09F
		rcall   lcd_cmd        ;     
		ldi     temp,0xA4      ;    
		rcall   lcd_cmd        ;     
		ldi     temp,0xA6      ;  
		;ldi     temp,0xA7     ;  
		rcall   lcd_cmd        ;     
		;ldi     temp,0xC8     ;   ; NOKIA 6085 small LCD!
		;rcall   lcd_cmd       ;     
		ldi     temp,0xAF      ;  
		rcall   lcd_cmd        ;     
		rcall   clr_lcd        ;     
		ret                    ; 

;================================================================================
clr_line:              ;  
		ldi    xl,low (96)     ;    
		ldi    xh,high(96)     ; 
		ldi    temp,0          ;   
		rjmp   clr_c           ;    
clr_lcd:               ; 
		ldi temp,0				;   1- 
		rcall set_X				;
		ldi temp,0				;  1- 
		rcall set_Y				;
	
		ldi    xl,low (864)    	;    96*9 = 864 
		ldi    xh,high(864)    	; 
		ldi    temp,0           ;   
clr_c:                 ;  
		rcall  lcd_data        	;     
		sbiw   xl,1            	;  
		brne   clr_c           	;    0 -    
		ret                    	;

;================================================================================
;		     .
;	      temp
;--------------------------------------------------------------------------------
lcd_cmd:       ;  
		cbi LCD_PORT,LCD_CS         ;CS  -> 0  
		cbi LCD_PORT,LCD_SCLK       ;CLK -> 0
		rcall delay1				; 
		cbi LCD_PORT,LCD_SDA        ;DAT -> 0   
		rjmp trd_clk        		;    
		
lcd_data:    ;   
		cbi LCD_PORT,LCD_CS         ;CS  -> 0  
		cbi LCD_PORT,LCD_SCLK       ;CLK -> 0
		rcall delay1				; 
		sbi LCD_PORT,LCD_SDA        ;DAT -> 1   
		
trd_clk:	;  
		cli
		rcall delay1				; 
		sbi LCD_PORT,LCD_SCLK       ;CLK -> 1    
		rcall delay2				; 
		cbi LCD_PORT,LCD_SCLK       ;CLK -> 0   
		
		rcall delay1				; 
		cbi LCD_PORT,LCD_SDA        ;DATA -> 0
		rcall delay1				; 
		;
		push temp2           		;   temp2
		push temp            		;   temp
		ldi temp2,8         		;  
out_byte:      	;    
		rcall delay1				; 
		cbi LCD_PORT,LCD_SDA        ;DATA -> 0
		sbrc temp,7          		;   = 1,-  -
		sbi LCD_PORT,LCD_SDA        ;DATA -> 1   
		
		rcall delay1				; 
				;  
		sbi LCD_PORT,LCD_SCLK       ;CLK -> 1    
		rcall delay2				; 
		cbi LCD_PORT,LCD_SCLK    	;CLK -> 0   
		
		rcall delay1				; 
		cbi LCD_PORT,LCD_SDA        ;DATA -> 0
		rcall delay1				; 
		
		rol temp            		;   temp = <<1 
		dec temp2          			;  
		brne out_byte        		;  ,    
		;
		rcall delay2				; 
		sbi LCD_PORT,LCD_CS         ;CS -> 1    
		pop temp            		; temp  
		pop temp2           		; temp2  
		
		sei
		ret                    		;

;=======================================================================================
;	      ASCII    6x8 
;	     temp  	()
;---------------------------------------------------------------------------------------
print_char_6x8:
		cli
		push  temp
		push  temp2            ;
		push  ZL               ;
		push  ZH               ;
		;    
		cpi temp,168					;    
		brne  fnt_3						;
		subi temp,(-24)					;    
		rjmp fnt_1						;
fnt_3:	cpi temp,184					;    
		brne  fnt_2						;
		subi temp,(-9)					;    
		rjmp fnt_1						;
		
fnt_2:	cpi temp,128					;    128
		brmi fnt_1						;    
		subi temp,64					;
		
fnt_1:	clr temp2 						;
		ldi ZL,low(font_tab*2-32*5) 	;  
		ldi ZH,high(font_tab*2-32*5) 	;   
		add ZL,temp 					;   
		adc ZH,temp2 					;
		lsl temp 						;    2
		rol temp2 						;
		lsl temp 						;
		rol temp2 						;
		add ZL,temp 					;  
		adc ZH,temp2 					;
		
		;    ASCII
		ldi   temp2,5          	;      
pr_ch_5:
		lpm temp,Z+          	;    
		rcall lcd_data         	;   
		dec temp2            	;   ,
		brne pr_ch_5          	;    ,   
		;
		clr temp		       	;  
		rcall lcd_data         	;   
		pop   ZH               	;
		pop   ZL               	;
		pop   temp2            	;
		pop   temp            	;
		
		sei
		ret                    	;
		
;==================================================================================
;       ASCII    68 
; 	        0.	()
; 	  Z -   ;
;-----------------------------------------------------------------------------------
	Str_LCD:
		cli
		push ZL					;   
		push ZH					;  
next:	lpm 					;  
		tst r0					;    0,  -
		breq w_str				;  
		mov temp,r0				;
		rcall print_char_6x8	;   LCD
		adiw Z,1				;   .
		rcall delay2
		rjmp next
		
		
w_str:	pop ZH					;  
		pop ZL					;  
		sei
 		ret
		
;=======================================================================================
;         	()
;---------------------------------------------------------------------------------------
delay1:		push r16		;
			ldi r16,2		;  
			dec r16			; 
			brne PC-1		;  
			pop r16			;
			ret
			
delay2:		push r16		;
			ldi r16,3		;  
			dec r16			; 
			brne PC-1		;  
			pop r16			;
			ret
			
;========================================================================================
;		     LCD 	()
;		  temp   
;----------------------------------------------------------------------------------------
 set_X:		;     ( )
 		cli
 		dec temp					;
 		ldi temp3,6           		;    
		muls temp,temp3           	;   
 		mov temp,R0					;   R0
 		swap temp					; 
 		andi temp,0b00000111   		; .  
 		ori temp,0b00010000   		;  
 		rcall  lcd_cmd         		;   .    LCD
 		mov temp,R0					;   R0
 		andi temp,0b00001111   		; .  
 		rcall  lcd_cmd         		; .    LCD
 		
 		sei
 		ret
 		
;----------------------------------------------------------------------------------------
 set_Y:		;   ( Y)
 		cli
 		ori temp,0xB0 				;   Y
 		rcall  lcd_cmd         		;
 		sei
		ret                    		;
		
;========================================================================================
;		       ()
;  temp -  
;------------------------------------------------------------------------------
Dig_x2:  	
		push  ZL               ;
		push  ZH               ;
		;    
		ldi ZL,LOW((Dig_0)*2)	;  1-  
		ldi ZH,HIGH((Dig_0)*2)	; .   0
		
		tst temp				;   0, 
		breq dig_w				;   
adr_dg:	adiw Z,24				;   
		dec temp				;   , -
		brne adr_dg				;  . 
		
dig_w:		;   
		ldi temp1,12			;   
ww_b:	lpm temp,Z+          	;    
		rcall lcd_data         	;   
		dec temp1            	;   ,
		brne ww_b          		;    ,  
		;     
		mov temp,r6				;  
		rcall set_X				;
		ldi temp,4				;  4 
		rcall set_Y				;
		;   
		ldi temp1,12			;   
wv_b:	lpm temp,Z+          	;    
		rcall lcd_data         	;   
		dec temp1            	;   ,
		brne wv_b          		;    ,  
		
		;     
		ldi temp,2				;   
		add r6,temp				;
		mov temp,r6				;  
		rcall set_X				;
		ldi temp,3				;  4 
		rcall set_Y				;
		
		pop   ZH               	;
		pop   ZL               	;
		ret
;============================================================================


.exit


